unit unitdb;

{$mode objfpc}{$H+}

interface

uses sqlite3conn, sqldb, Grids;

procedure InitConnection;
procedure SelectSQL (var aGrid: TStringGrid; SQLstr: string);

var   SQLite: TSQLite3Connection;
      SQLQuery: TSQLQuery;
      SQLTransaction: TSQLTransaction;

implementation

procedure InitConnection;
begin
  SQLite := TSQLite3Connection.Create(nil);
  SQLite.DatabaseName := 'MyDB.db3';
  SQLite.Connected := True;
  SQLTransaction := TSQLTransaction.Create(nil);
  SQLTransaction.DataBase := SQLite;
  SQLTransaction.Action := caCommit;
  SQLTransaction.Active := True;
  SQLTransaction.Commit;
  SQLQuery := TSQLQuery.Create(nil);
  SQLQuery.DataBase := SQLite;
  SQLQuery.Transaction := SQLTransaction;
end;

procedure SelectSQL (var aGrid: TStringGrid; SQLstr: string);
var   i: byte;
begin
  SQLTransaction.Active := True;
  SQLTransaction.Commit;
  SQLTransaction.StartTransaction;
  SQLQuery.SQL.Clear;
  SQLQuery.SQL.Add(SQLstr);
  SQLQuery.Open;
  SQLQuery.Last;
  aGrid.RowCount := SQLQuery.RecordCount + 1;
  SQLQuery.First;
  while not SQLQuery.Eof do
  begin
    for i := 0 to aGrid.ColCount - 1 do aGrid.Cells[i, SQLQuery.RecNo] := SQLQuery.Fields[i].AsString;
    SQLQuery.Next;
  end;
  SQLQuery.Close;
  SQLTransaction.Commit;
end;

end.

